﻿;03 songs
;Master of Magic, C64 music, playing under interrupt on ZXS, MB03+ or ZX Element
;tools: https://masswerk.at/6502/6502_instruction_set.html

;aux code for the game Master Of Magic
	output 24500
		org 24500
start		xor	a
		out	(#FE),a
	
		ld	bc,#703B	;activate SID in MB03
		ld	a,1
		out	(c),a
		inc	b
		in	a,(c)
		set	5,a
		out	(c),a

		dec	b		;select model
		ld	a,19
		out	(c),a
		inc	b
		xor	a		;model 6581, freq PAL
		out	(c),a

		ld	b,#78		;...and in ZXeLeMeNt
		ld	a,2
		out	(c),a
		inc	b
		in	a,(c)
		set	3,a
		out	(c),a

		dec	b		;model 6581, freq PAL
		ld	a,19
		out	(c),a
		inc	b
		xor	a
		out	(c),a
starthry	jp	#8ca0		;start #8f90


;main play routine
strankovani	ld	a,#11		;8ece, ld a,(#8db7)-> call strankovani
		ld	bc,#7ffd
		out	(c),a
		push	bc
		call	player
		ld	a,#10
		pop	bc
		out	(c),a
		ld	a,(#8db7)	;back to IM2
		ret

setmus		ld	(poke_trk),a
		ret
poke_trk	db	#55		;c.hudby/zvuku, specifikace: bity 0-4=c.tracku
					;bit 5=init fx, 0 ne, 1 ano

;re/start game
maintrk		ld	a,0+#20		;8e02, call #7035-> call maintrk
		call	setmus
		jp	#7035

gameover	ld	a,1+#20		;942d, call #d452-> call gameover
go1		call	setmus
		jp	#d452

success		ld	a,2+#20		;978b, call #d452-> call success
		jr	go1
		









	output	MOM
	org	51200
/*
;player					;entry point to IM2 player routine

		ld	de,lastk	;press "1" to change sound status
		ld	hl,sidstatus
		ld	c,#31
		ld	a,(de)
		ld	b,a
		ld	a,(#5C04)
		cp	c		;is key "1" pressed?
		ld	a,b		;A=last key either 0 or "1"
		jr	z,tk1		;Z=yes, key "1" is pressed

		or	a		;key "1" is not pressed
		ld	c,0		;was last key "1"?
		ld	a,c
		jr	nz,tk12		;NZ=yes, was "1",border 0, lastk=0
		jr	tk13
		


tk1		or	a		;key "1" is pressed
		ret	nz		;last key was also "1", ret
		inc	(hl)
		bit	2,(hl)
		jr	z,tk11
		ld	(hl),0
tk11		ld	a,(hl)		;A=current sid status
		inc	a
tk12		out	(#FE),a		;change border
		ld	a,c
tk13		ld	(de),a		;save last key as "1"
		ld	a,(hl)
		or	a
		jr	nz,play_main

		ld	a,(poke_trk)
		cp	#20
		jr	z,tk14
		cp	#21
		jr	z,tk14
		cp	#22
		jr	nz,tk15
tk14		res	5,a
		call	initmusic	;always init new music, so that it can play when
					;sidstatus changes to 2 or 3

tk15		ld	hl,sidstatus	;sidstatus=0, mute SID and return
		ld	(hl),1
		push	hl
		call	mutesid
	ld	a,#FF			;if #FF, then music 0 sometimes replays from start
;;	ld	a,#20			;#20 inits music every time sidstatus changes 0,1,2,3
	ld	(newinit+1),a	;put #FF, or music number 0,1,2 
	ld	(poke_trk),a

		pop	hl
		ld	(hl),0
		jp	sng_end		;GO change
;		ret			;if user selected mute SID, then return here

;end of new code

sidstatus	db	3		;3=initial value, either 3,2,1,0
					;0=all off
					;1= ZX beeper
					;2= music
					;3= music+ ZX beeper
lastk		db	0		;either "1" or 0

*/

;D= x
;E= y

player
play_main
	ld	hl,poke_trk	;here music processing itself starts
	ld	a,(hl)

	bit	5,(hl)		;check if new incoming music
	res	5,(hl)		;YES= initialise it
	ld	(hl),a		;NO= play it
	jr	z,playmusic

;	jp	initmusic
;	jp	playmusic
;	jp	musicoff

initmusic
;	ld	a,0		;music num
	ld	e,0	
	sla	a
	ld	hl,tempstore
	ld	(hl),a
	sla	a
	add	a,(hl)
	ld	(hl),a		;now music num*6
	ld	d,a

loop1	ld	hl,songs	;copy ptrs to this
	call	lda_adr_x	;music’s tracks to
	ld	hl,currtrkhi
	call	sta_adr_y
	inc	d		;current tracks
	inc	e
	ld	a,e
	cp	6
	jr	nz,loop1	;checked_ok

	xor	a		;clear control regs
	ld	l,#04
	call	write_regs
	ld	l,#0B
	call	write_regs
	ld	l,#12
	call	write_regs
	ld	l,#17
	call	write_regs
	ld	a,#F		;full volume
	ld	l,#18
	call	write_regs
	ld	a,#40
	ld	(mstatus),a
	ret
;====================================
;music off

musicoff
	ld	a,#c0		;flag music off
	ld	(mstatus),a
	ret
;====================================
;play music
playmusic


	ld	hl,counter
	inc	(hl)

	ld	a,(mstatus)	;test music status
	bit	7,a
	jr	nz,moff		;#80 and #c0 is off, checked ok
	bit	6,a
	jr	z,contplay	;#40 init, else play, checked ok


;==========
;init the song (mstatus $40)

	ld	a,0		;init counter
	ld	(counter),a
	ld	hl,posoffset
	ld	de,posoffset+1
	ld	bc,8
	ld	(hl),a
	ldir			;init pos-, pat-, lengthleft offsets

	ld	(notenum+1),bc	;get note right away
	ld	a,c
	ld	(notenum),a



	ld	(mstatus),a
	jp	contplay



;==========
;music is off (mstatus $80 or $c0)

moff

	jr	z,jp1		;if mstatus #C0 then
	xor	a
	ld	l,04
	call	write_regs	;kill voice 1,2,3
	ld	l,#0b
	call	write_regs	;control registers
	ld	l,#12
	call	write_regs
	ld	a,#f		;full volume still
	ld	l,#18
	call	write_regs	;full volume still
	ld	a,#80		;flag no need to kill
	ld	(mstatus),a
jp1	jp	musicend	;end

;==========
;music is playing (mstatus otherwise)
contplay

	ld	d,#3-1		;number of chanels
	ld	hl,speed
	dec	(hl)		;check the speed
	jp	p,mainloop	;asi ok, tez zkusit bit 7= zaporne cislo

	ld	a,(resetspd)    ;reset speed if needed
	ld	(speed),a

mainloop
	ld	hl,regoffsets	;save offset to regs
	call	lda_adr_x	;for this channel
	ld	(tmpregofst),a
	ld	e,a

;check whether a new note is needed

	ld	a,(speed)	;if speed not reset
	ld	hl,resetspd	;then skip notework
	cp	(hl)
	jp	nz,vibrato	;checked ok

checknewnote
	ld	hl,currtrkhi	;put base addr.w of
	call	lda_adr_x	;this track in #2
	ld	(mem02),a
	ld	hl,currtrklo
	call	lda_adr_x
	ld	(mem03),a

	ld	hl,lengthleft
	call	dec_adr_x	;check wether  new
				;note is needed
	jp	p,soundwork	;no new note need, checked ok

;==========
;notework
;a new note is needed. get the pattern
;number/cc from this position

getnewnote
	ld	hl,posoffset	;get the data from
	call	ldy_adr_x	;the current posit.
	ld	hl,(mem02)
	call	lda__adr__y
	cp	#FF		;pos #FF restarts
	jr	z,restart	;checked ok

	cp	#fe		;pos #FE stops music
	jr	nz,getnotedata	;on all channels, checked ok
	jp	musicend

;cc of $ff restarts this track from the
;first position

restart
	xor	a	;get note immediatelly
	ld	hl,lengthleft	;and reset pat, pos
	call	sta_adr_x
	ld	hl,posoffset
	call	sta_adr_x
	ld	hl,patoffset
	call	sta_adr_x
	jp	getnewnote

;get the note data from this pattern
getnotedata
	ld	e,a
	ld	hl,patptl	;put base addr.w of
	call	lda_adr_y	;the pattern in #4
	ld	(mem04),a
	ld	hl,patpth
	call	lda_adr_y
	ld	(mem05),a


;	xor	a	;default no portamento
;	ld	hl,portaval
;	call	sta_adr_x

	ld	hl,patoffset	;get offset into ptn
	call	ldy_adr_x

	ld	a,#FF		;default no append
	ld	(appendfl),a

;1st byte is the length of the note 0-31
;bit5 signals no release (see sndwork)
;bit6 signals appended note
;bit7 signals a new instrument
;     or portamento coming up
	ld	hl,(mem04)	;get length of note
	call	lda__adr__y
	ld	hl,savelnthcc
	call	sta_adr_x
	ld	(templnthcc),a
	and	#1F
	ld	hl,lengthleft
	call	sta_adr_x
;new code
	ld	a,#75
	ld	hl,posoffset+2
	sub	(hl)
	cp	#F
	jr	c,gnd1
	ld	a,#F
gnd1	ld	l,#18
	call	write_regs

	ld	hl,templnthcc
	bit	6,(hl)		;test for append
	jr	nz,appendnote	;asi ok

	ld	hl,patoffset
	call	inc_adr_x	;pt to next data
	ld	a,(templnthcc)	;2nd byte needed
	or	a
	jp	p,getpitch	;checked ok

;2nd byte needed as 1st byte negative
;2nd byte is the instrument number(+ve)
;or portamento speed(-ve)
	inc	e
	ld	hl,(mem04)
	call	lda__adr__y     ;get instr/portamento
	ld	hl,instrnr
	call	sta_adr_x
	ld	hl,patoffset
	call	inc_adr_x

/*old code
	or	a
	jp	p,loop10	;checked ok

	ld	hl,portaval
	call	sta_adr_x         ;save portamento val
	jr	loop4

loop10	ld	hl,instrnr
	call	sta_adr_x	;save instr nr

loop4	ld	hl,patoffset
	call	inc_adr_x
*/

;3rd byte is the pitch of the note
;get the 'base frequency' here
getpitch
	inc	e
	ld	hl,(mem04)
	call	lda__adr__y	;get pitch of note
	ld	hl,notenum
	call	sta_adr_x
	sla	a		;pitch*2
	ld	e,a
	ld	hl,frequenzlo
	call	lda_adr_y         ;save the appropriate
	ld	(tempfreq),a	;base frequency
	ld	hl,frequenzhi
	call	lda_adr_y	;oprava, bylo sta
	ld	h,a		;A we want to write
	ld	a,(tmpregofst)
	ld	e,a		;oprava, přidáno
	inc	a		;#d401, radši zkontrolovat v debuggeru
	ld	l,a		;L=reg nr
	push	hl
	ld	a,h		;oprava, bylo h,a
	call	write_regs
	ld	hl,savefreqhi
	call	sta_adr_x
	ld	a,(tempfreq)
	pop	hl		;o 1< než frqhi
	dec	l		;#d400		
	call	write_regs
	ld	hl,savefreqlo
	call	sta_adr_x
	jr	loop5

appendnote
	ld	hl,appendfl	;clever eh?
	dec	(hl)
;fetch all the initial values from the
;instrument data structure
loop5	ld	a,(tmpregofst)
	ld	e,a
	ld	hl,instrnr
	call	lda_adr_x		;instr num
	push	af
	ld	a,d			;oprava, bylo e
	ld	(tempstore),a
	pop	af
	sla	a		;instr num*8
	sla	a
	sla	a
	ld	d,a		;oprava, bylo e

	ld	hl,instr+2
	call	lda_adr_x	;get control reg val
	ld	(tempctrl),a
	ld	hl,appendfl	;implement append
	and	(hl)
	push	af
	ld	a,e
	add	a,4
	ld	l,a
	pop	af
	call	write_regs
	ld	hl,instr+0	;get pulse width lo
	call	lda_adr_x
	push	af
	ld	a,e
	add	a,2
	ld	l,a
	pop	af
	call	write_regs
	ld	hl,instr+1	;get pulse width hi
	call	lda_adr_x
	push	af
	ld	a,e
	add	a,3
	ld	l,a
	pop	af
	call	write_regs
	ld	hl,instr+3	;get attack/decay
	call	lda_adr_x
	push	af
	ld	a,e
	add	a,5
	ld	l,a
	pop	af
	call	write_regs
	ld	hl,instr+4	;get sustain/release
	call	lda_adr_x
	push	af
	ld	a,e
	add	a,6
	ld	l,a
	pop	af
	call	write_regs

	ld	a,(tempstore)
	ld	d,a		;save control reg val, oprava, bylo e
	ld	a,(tempctrl)
	ld	hl,voicectrl
	call	sta_adr_x

;4th byte checks for the end of pattern
;if eop found, inc the position and
;reset patoffset for new pattern

	ld	hl,patoffset	;preview 4th byte
	push	hl
	call	inc_adr_x
	pop	hl
	call	ldy_adr_x
	ld	hl,(mem04)
	call	lda__adr__y

	cp	#FF	             ;check for end of eop
	jr	nz,loopc	;checked ok

	ld	a,0		;end of pat reached
	ld	hl,patoffset	;inc position for
	call	sta_adr_x	;the next time
	ld	hl,posoffset
	call	inc_adr_x
loopc	jp	loopcont
;==========
;soundwork
;the instrument and effects processing
;routine when no new note was needed

soundwork 

;release routine
;set off a release when the length of
;the note is exceeded
;bit4 of the 1st note-byte can specify
;for no release
	ld	a,(tmpregofst)
	ld	e,a
	ld	hl,savelnthcc    ;check for no release
	call	lda_adr_x		;specified
	and	#20
	jr	nz,vibrato	;checked ok

	ld	hl,lengthleft     ;check for length of
	call	lda_adr_x		;exceeded
	or	a
	jr	nz,vibrato

	ld	hl,voicectrl	;length exceeded so
	call	lda_adr_x
	and	#fe		;start the release
	push	af
	ld	a,e
	add	a,4
	ld	l,a
	pop	af
	call	write_regs	;and kill adsr
	xor	a
	inc	l
	call	write_regs
	inc	l
	call	write_regs
;vibrato routine
;(does alot of work)
vibrato
	ld	hl,instrnr
	call	lda_adr_x
	sla	a
	sla	a
	sla	a		;instr num*8
	ld	e,a
	ld	(instnumby8),a	;save instr num*8
	ld	hl,instr+7
	call	lda_adr_y	;get instr fx byte
	ld	(instrfx),a
	ld	hl,instr+6
	call	lda_adr_y
	ld	(pulsevalue),a	;get pulse speed
	ld	hl,instr+5
	call	lda_adr_y
	ld	(vibrdepth),a	;get vibrato depth
	or	a
	jp	z,pulsew
;	jp	z,pulsework     ;check for no vibrato, checked ok

	ld	a,(counter)	;this is clever!!
	and	7	        ;the counter’s turned
	cp	4		;into an oscillating
	jr	c,osc1		;value (01233210);opraveno, celé přepsáno pro Z80,checked in emul, ok

	cpl	
	and	7
osc1	ld	(oscilatval),a
	ld	hl,notenum	;get base note
	call	lda_adr_x
	sla	a		;note*2
	ld	e,a		;get diff btw note
	ld	hl,frequenzlo
	call	lda_adr_y
	push	af		;opraveno, byla ld h,a
	ld	hl,frequenzlo+2
	call	lda_adr_y
	pop	hl

;	scf			;and note+1 frequency
	sub	h		;Busy reparation
;	sbc	a,h

	ld	(tmpvdiflo),a
	ex	af,af'		;save carry
	ld	hl,frequenzhi
	call	lda_adr_y
	push	af		;opraveno, byla ld h,a
	ld	hl,frequenzhi+2
	call	lda_adr_y
	pop	hl

	ld	c,a
	ex	af,af'		;carry from previous substraction
	ld	a,c

	sbc	a,h		;Busy reparation
loop6	srl	a		;divide difference by
	ld	hl,tmpvdiflo
	rr	(hl)	             ;2 for each vibrdepth
	ld	hl,vibrdepth
	dec	(hl)
	jp	p,loop6		;oprava, bylo: jr	z,loop6

	ld	(tmpvdifhi),a
	ld	hl,frequenzlo
	call	lda_adr_y          ;save note frequency
	ld	(tmpvfrqlo),a
	ld	hl,frequenzhi
	call	lda_adr_y
	ld	(tmpvfrqhi),a
	ld	hl,savelnthcc	;no vibrato if note
	call	lda_adr_x
	and	#1f		;length less than 8
;	cp	8
	cp	4
	jr	c,plvibr	;C= no vibrato,checked in emul, ok
	ld	a,(oscilatval)
	ld	e,a
loop3	dec	e             ;depending on the osc
	jp	m,plvibr	;value, add the vibr, checked ok
	
	ld	hl,tmpvfrqlo	;to the base freq
	ld	a,(tmpvdiflo)
	add	a,(hl)
	ld	(hl),a
	ld	hl,tmpvfrqhi
	ld	a,(tmpvdifhi)
	adc	a,(hl)		;Busy reparation
	ld	(hl),a
	jr	loop3

plvibr	ld	a,(tmpregofst)	;save the final
	ld	e,a		;frequencies
;	ld	l,0
;	add	a,l		;opraveno l+e
	ld	l,a		;opraveno, bylo a,l
	ld	a,(tmpvfrqlo)
	call	write_regs
	ld	a,(tmpvfrqhi)
	inc	l
	call	write_regs

;new code for MOM music
pulsew	ld	a,(instrfx)	;c20c, ok
;pulsew	ld	a,(portaval)	;not ok
	and	#08
	jr	z,pulsework

	ld	a,(instnumby8)	;LDY #C41C ok
	ld	e,a
;	ld	hl,curtrkhi
	ld	hl,instr+0	;LDA #C427,Y 
	call	lda_adr_y
	push	hl
	ld	hl,pulsevalue	;ADC #C40E OK
	add	a,(hl)
	pop	hl
	ld	(hl),a
	ld	b,a
	ld	a,(tmpregofst)
	ld	e,a
	ld	l,2
	add	a,l
	ld	l,a
	ld	a,b
	call	write_regs
		jp	drums	;chyba
;pulse-width timbre routine
;depending on the control/speed byte in
;the instrument datastructure, the pulse
;width is of course inc/decremented to
;produce timbre
;strangely the delay value is also the
;size of the inc/decrements
pulsework 
	ld	a,(pulsevalue)   ;check for pulsework
	or	a
	jp	z,drums
;	jp	z,portamento	;needed this instr, checked ok

	push	af
	ld	a,(instnumby8)
	ld	e,a
	pop	af
	and	#1F
	ld	hl,pulsedelay
	call	dec_adr_x	;pulsedelay-1
	jp	p,drums
;	jp	p,portamento	;checked ok
;	jp	m,portamento	;pozor, hudba hraje ok, ale asi by to tu byt nemelo

	ld	hl,pulsedelay
	call	sta_adr_x	;reset pulse delay

	ld	a,(pulsevalue)	;restrict pulse speed
	and	#e0		;from 0-#1F
	ld	(pulsespeed),a

	ld	hl,pulsedir
	call	lda_adr_x	;pulsedir 0 is up and
	or	a
	jr	nz,pulsedown	;1 is down, checked ok


	ld	hl,instr+0           ;add the pulse speed
	call	lda_adr_y
	ld	c,a
	ld	a,(pulsespeed)	;pulse width up
	add	a,c		;Busy reparation
	push 	af		;to the pulse width
	ld	hl,instr+1
 	call	lda_adr_y
	ld	b,a
	pop	af
	push	af
	ld	a,b		;add carry, Busy's reparation
	adc	a,#00
	and	#F
 	push	af
	cp	#0E	              ;go pulsedown when
	jr	nz,dumpulse	;the pulse value

	ld	hl,pulsedir
	call	inc_adr_x          ;reaches max (#0exx)
	jr	dumpulse

pulsedown
	ld	hl,instr+0
	call	lda_adr_y
	ld	hl,pulsespeed	;pulse width down

;	scf
;	sbc	a,(hl)

	sub	(hl)		;Busy raparation, was ok
	push	af
	ld	hl,instr+1
	call	lda_adr_y
	ld	b,a
	pop	af
	push	af
	ld	a,b		;Busy reparation
	sbc	a,#00		;carry?
	and	#0F
	push	af
	cp	#8		;go pulse up when
	jr	nz,dumpulse	;the pulse value, checked ok
	ld	hl,pulsedir         ;reaches min (#08xx)
	call	dec_adr_x

dumpulse
	ld	a,d		;oprava, bylo ld a,e
	ld	(tempstore),a	;dump pulse width to
	ld	a,(tmpregofst)	;chip and back into
	ld	d,a		;the instr data str, oprava, bylo e,a
	pop	af
	ld	hl,instr+1
	call	sta_adr_y
	ld	h,a
	ld	a,d
	add	a,3
	ld	l,a
	ld	a,h
	call	write_regs
	pop	af
	ld	hl,instr+0
	call	sta_adr_y
	ld	h,a
	ld	a,d
	add	a,2
	ld	l,a
	ld	a,h
	call	write_regs
	ld 	a,(tempstore)
	ld	d,a
;portamento routine
;portamento comes from the second byte
;if it's a negative value
/*portamento not used in MOM music
portamento 
	
	ld	a,(tmpregofst)
	ld	e,a
	ld	hl,portaval
	call	lda_adr_x    ;check for portamento
	or	a
	jr	z,drums		;none, checked ok

	and	#7e		;toad unwanted bits
	ld	(tempstore),a

	ld	hl,portaval
	call	lda_adr_x         ;bit0 signals up/down
	and	#01
	jr	z,portup	;checked ok


	ld	hl,savefreqlo	;portamento down
	call	lda_adr_x
	push	hl
	ld	hl,tempstore	;sub portaval from

;	scf			;current frequency
;	sbc	a,(hl)

	sub	(hl)		;Busy reparation
	pop	hl
	push	af		;save carry
	ld	(hl),a		;A->savefreqlo,x
	ld	l,e
	call	write_regs
	ld	hl,savefreqhi
	call	lda_adr_x
	ld	b,a
	pop	af		;pop carry flag
	ld	a,b		;Busy reparation
	sbc	a,#00		;(word aritmetic)
	ld	hl,savefreqhi
	call	sta_adr_x
	ld	h,a
	ld	a,e
	add	a,1
	ld	l,a
	ld	a,h
	call	write_regs
	jp	drums
portup
	ld	hl,savefreqlo	;portamento up
	call	lda_adr_x
	push	af
	ld	a,(tempstore)
	ld	b,a
	pop	af
	add	a,b		;add portval to
	push	af		;save carry
	ld	(hl),a		;current frequency, oprava celého úseku
	ld	h,a
	ld	a,e		;oprava, bylo e
	ld	l,a
	ld	a,h
	call	write_regs
	ld	hl,savefreqhi
	call	lda_adr_x
	ld	b,a
	pop	af		;return carry
	ld	a,b
	adc	a,#00
	ld	(hl),a
	ld	h,a
	ld	a,e		;oprava, bylo e
	add	a,1
	ld	l,a
	ld	a,h
	call	write_regs
*/
;bit0 instrfx are the drum routines
;the actual drum timbre depends on the
;crtl register value for the instrument:
;ctrlreg 0 is always noise
;ctrlreg x is noise for 1st vbl and x
;from then on
;see that the drum is made by rapid hi
;to low frequency slide with fast attack
;and decay
drums
	ld	a,(instrfx)	;check if drums
	and	#01		;needed this instr
	jr	z,skydive	;checked ok

	ld	hl,savefreqhi	;don’t bother if freq
	call	lda_adr_x
	or	a		
	jr	z,skydive	;can’t go any lower;checked ok

	ld	hl,lengthleft	;or if the note has
	call	lda_adr_x	;finished
	or	a
	jr	z,skydive	;checked ok

	ld	hl,savelnthcc	;check if this is the
	call	lda_adr_x	;first vbl for this
	and	#1F
;	scf
;	sbc	a,#01		;instrument- note
	dec	a		;Busy reparation
	push	af		;oprava, bylo ld l,a
	ld	hl,lengthleft
 	call	lda_adr_x
	ld	l,a
	pop	af
	cp	l
	ld	a,(tmpregofst)
	ld	e,a
	jr	c,firstime	;checked with ear, C is ok

	ld	hl,savefreqhi	;not the first time
	call	lda_adr_x
	dec	(hl)		;so dec freqhi for
	ld	h,a
	ld	a,e
	add	a,1
	ld	l,a
	ld	a,h
	call	write_regs	;drum sound

	ld	hl,voicectrl
	call	lda_adr_x	;if ctrlreg is 0 then
	and	#FE	        ;noise is used always
	jr	nz,dumpctrl	;checked ok
firstime
	ld	hl,savefreqhi	;noise is used for
	call	lda_adr_x	;the first vbl also
	ld	h,a
	ld	a,e
	add	a,1
	ld	l,a
	ld	a,h
	call	write_regs
	ld	a,#80		;(set noise)
dumpctrl
	push	af
	ld	a,e
	add	a,4
	ld	l,a
	pop	af
	call	write_regs

;bit1 instrfx is the skydive
;a long portamento-down from the note
;to zerofreq

skydive
	ld	a,(instrfx)	;check if skydive
	and	#02		;needed this instr
	jr	z,octarp	;checked ok

;new code
	ld	hl,savelnthcc
	call	lda_adr_x
	and	#1F
	cp	#10
	jr	c,octarp

	ld	hl,lengthleft
	call	lda_adr_x
	cp	#12
	jr	nc,octarp
;end new code

	ld	a,(counter)	;every 2nd vbl
	and	#01
	jr	z,octarp	;checked ok

	ld	hl,savefreqhi	;check if skydive
	call	lda_adr_x
	or	a		;already complete
	jr	z,octarp	;checked ok

	dec	(hl)		;decr and save the, čekni, zda je to ok při trasování!!!
	ld	h,a
	ld	a,(tmpregofst)
	ld	e,a		;high byte freq
	add	a,1
	ld	l,a
	ld	a,h
	call	write_regs
;bit2 instrfx is an octave arpeggio
;pretty tame huh?
octarp
	ld	a,(instrfx)	;check if arpt needed
	and	#04
	jr	z,loopcont	;checked ok

	ld	a,(counter)	;only 2 arpt values
	and	#07
;	and	#01
	jr	z,loop40

	ld	hl,notenum	;odd,note+12
	call	lda_adr_x
	add	a,#0C
	jr	loop7

loop40	ld	hl,notenum	;even, note
	call	lda_adr_x
loop7	sla	a	;dump the corresponding
	ld	e,a	;frequencies
	ld	hl,frequenzlo
	call	lda_adr_y
	ld	(tempfreq),a
	ld	hl,frequenzhi
	call	lda_adr_y
	ld	h,a
	ld	a,(tmpregofst)	;opraveno
	ld	e,a
	add	a,1
	ld	l,a
	ld	a,h
	call	write_regs
	ld	a,e
	add	a,0
	ld	l,a
	ld	a,(tempfreq)
	call	write_regs
	;==============
;end of dbf loop

loopcont
	dec	d		;dbf mainloop
	jp	m,musicend
	jp	mainloop
musicend
	ret


;auxiliary routines
;write_regs_params	;in=h=step…not applied
write_regs			;write to SID register
	ld	bc,reg_wr	;in=l=reg, a=value
	out	(c),l
	inc	b
	out	(c),a
	ret
reg_wr	equ	#6C3b


lda_adr_x
	ld	b,0
	ld	c,d
	add	hl,bc
	ld	a,(hl)
	ret

lda_adr_y
	ld	b,0
	ld	c,e
	add	hl,bc
	ld	a,(hl)
	ret

sta_adr_y
	ld	b,0
	ld	c,e
	add	hl,bc
	ld	(hl),a
	ret

sta_adr_x
	ld	b,0
	ld	c,d
	add	hl,bc
	ld	(hl),a
	ret

ldy_adr_x
	ld	b,0
	ld	c,d
	add	hl,bc
	ld	e,(hl)
	ret

lda__adr__y
	ld	b,0
	ld	c,e
	add	hl,bc
	ld	a,(hl)
	ret

dec_adr_x	;OUT=Z/NZ
	ld	b,0
	ld	c,d
	add	hl,bc
	dec	(hl)
	ret

inc_adr_x	;OUT=Z/NZ
	ld	b,0
	ld	c,d
	add	hl,bc
	inc	(hl)
	ret


mem02	ds	1		;current position
mem03	ds	1
mem04	ds	1		;lenght of note?
mem05	ds	1




;====================================
;frequenz data
;====================================

frequenzlo	db #16
frequenzhi	db #01
	db #27,#01,#38,#01,#4b,#01
	db #5f,#01,#73,#01,#8a,#01,#a1,#01
	db #ba,#01,#d4,#01,#f0,#01,#0e,#02
	db #2d,#02,#4e,#02,#71,#02,#96,#02
	db #bd,#02,#e7,#02,#13,#03,#42,#03
	db #74,#03,#a9,#03,#e0,#03,#1b,#04
	db #5a,#04,#9b,#04,#e2,#04,#2c,#05
	db #7b,#05,#ce,#05,#27,#06,#85,#06
	db #e8,#06,#51,#07,#c1,#07,#37,#08
	db #b4,#08,#37,#09,#c4,#09,#57,#0a
	db #f5,#0a,#9c,#0b,#4e,#0c,#09,#0d
	db #d0,#0d,#a3,#0e,#82,#0f,#6e,#10
	db #68,#11,#6e,#12,#88,#13,#af,#14
	db #eb,#15,#39,#17,#9c,#18,#13,#1a
	db #a1,#1b,#46,#1d,#04,#1f,#dc,#20
	db #d0,#22,#dc,#24,#10,#27,#5e,#29
	db #d6,#2b,#72,#2e,#38,#31,#26,#34
	db #42,#37,#8c,#3a,#08,#3e,#b8,#41
	db #a0,#45,#b8,#49,#20,#4e,#bc,#52
	db #ac,#57,#e4,#5c,#70,#62,#4c,#68
	db #84,#6e,#18,#75,#10,#7c,#70,#83
	db #40,#8b,#70,#93,#40,#9c,#78,#a5
	db #58,#af,#c8,#b9,#e0,#c4,#98,#d0
	db #08,#dd,#30,#ea,#20,#f8,#2e,#fd


/*
regoffsets	db #00,#07,#0e
tmpregofst	db #00
posoffset	db #00,#00,#00
patoffset	db #09,#06,#09
lengthleft	db #0F,#0F,#0F
savelnthcc	db #17,#7F,#3F
voicectrl	db #41,#41,#41
notenum		db #5B,#68,#13
instrnr		db #06,#0C,#08
appendfl	db #FF
templnthcc	db #1F
tempfreq	db #42
tempstore	db #01
tempctrl	db #41
vibrdepth	db #FF
pulsevalue	db #00
tmpvdiflo	db #8E
tmpvdifhi	db #01
tmpvfrqlo	db #B4
tmpvfrqhi	db #D3
oscilatval	db #02
pulsedelay	db #00,#03,#13
pulsedir	db #01,#00,#00
speed		db #00
resetspd	db #01
instnumby8	db #30
mstatus		db #00
savefreqhi	db #D0,#00,#03
savefreqlo	db #98,#41,#42
portaval	db #00,#00,#00
instrfx		db #00
pulsespeed	db #E0
counter		db #E2
currtrkhi	db #00,#FF,#FF
currtrklo	db #28,#01,#28
*/


regoffsets	db #00,#07,#0e	;c3ef
tmpregofst	db #0e
posoffset	db #0b,#0c,#0c
patoffset	db #00,#00,#00
lengthleft	db #00,#00,#ff
savelnthcc	db #0f,#4f,#0f
voicectrl	db #11,#15,#41	;2x#41 taken from original SID file. If 0 here, then initial slide is missing+ music plays with different instruments in one place
notenum		db #18,#30,#18
instrnr		db #00,#00,#00
appendfl	db #00
templnthcc	db #00
tempfreq	db #00
tempstore	db #00
tempctrl	db #00
vibrdepth	db #00
pulsevalue	db #00
tmpvdiflo	db #00
tmpvdifhi	db #00
tmpvfrqlo	db #00
tmpvfrqhi	db #00
oscilatval	db #00
pulsedelay	db #00,#00,#00
pulsedir	db #00,#00,#00
speed		db #00
resetspd	db #01
instnumby8	db #00
mstatus		db #c0
savefreqhi	db #00,#00,#00
savefreqlo	db #00,#00,#00
portaval	db #00,#00,#00
instrfx		db #00
pulsespeed	db #00
counter		db #00
currtrkhi	db #00,#00,#00
currtrklo	db #00,#00,#00


;====================================
;monty on the run main theme
;====================================

songs 
	db low mommaintr1;main track
	db low mommaintr2
	db low mommaintr3
	db high mommaintr1
	db high mommaintr2
	db high mommaintr3

	db low momsuc1	;success
	db low momsuc2
	db low momsuc3
	db high momsuc1
	db high momsuc2
	db high momsuc3

	db low momgameover1	;game over
	db low momgameover2
	db low momgameover3
	db high momgameover1
	db high momgameover2
	db high momgameover3



;====================================
;pointers to the patterns

;low pointers
patptl
	db low ptn00
	db low ptn01
	db low ptn02
	db low ptn03
	db low ptn04
	db low ptn05
	db low ptn06
	db low ptn07
	db low ptn08
	db low ptn09
	db low ptn0a
	db low ptn0b
	db low ptn0c
	db low ptn0d
	db low ptn0e
	db low ptn0f
	db low ptn10
	db low ptn11
	db low ptn12
	db low ptn13
	db low ptn14
	db low ptn15
	db low ptn16
	db low ptn17
	db low ptn18
	db low ptn19
	db low ptn1a
	db low ptn1b
	db low ptn1c
	db low ptn1d
	db low ptn1e
	db low ptn1f
	db low ptn20
	db low ptn21
	db low ptn22
	db low ptn23
	db low ptn24
	db low ptn25
	db low ptn26
	db low ptn27
	db low ptn28



;high pointers
patpth 
	db high ptn00
	db high ptn01
	db high ptn02
	db high ptn03
	db high ptn04
	db high ptn05
	db high ptn06
	db high ptn07
	db high ptn08
	db high ptn09
	db high ptn0a
	db high ptn0b
	db high ptn0c
	db high ptn0d
	db high ptn0e
	db high ptn0f
	db high ptn10
	db high ptn11
	db high ptn12
	db high ptn13
	db high ptn14
	db high ptn15
	db high ptn16
	db high ptn17
	db high ptn18
	db high ptn19
	db high ptn1a
	db high ptn1b
	db high ptn1c
	db high ptn1d
	db high ptn1e
	db high ptn1f
	db high ptn20
	db high ptn21
	db high ptn22
	db high ptn23
	db high ptn24
	db high ptn25
	db high ptn26
	db high ptn27
	db high ptn28


;====================================
;tracks
;====================================

;track1
mommaintr1 
; db #14,#1F,#1F,#1F,#1F			;test
 db     #00,#00,#00,#00,#1B,#1D,#1D	;c519
 db #05,#06,#05,#06,#05,#0A,#0B,#0B
 db #0C,#0C,#0D,#0F,#11,#11,#12,#12
 db #13,#14,#14,#14,#14,#17,#19,#1B
 db #1D,#1D,#1D,#01,#02,#02,#03,#1E
 db #1E,#20,#05,#06,#05,#0A,#13,#12
 db #12,#0F,#11,#11,#14,#14,#14,#14
 db #00,#00,#00,#00,#00,#00,#00,#00
 db #00,#00,#00,#00,#00,#00,#00,#00
 db #FF

;track2
mommaintr2 
; db #14,#1F,#1F,#1F,#1F			;test
 db     #09,#09,#09,#09,#09,#09,#09	;c561
 db #09,#16,#16,#16,#16,#09,#09,#22
 db #22,#09,#09,#22,#22,#09,#09,#09
 db #09,#09,#09,#09,#09,#09,#09,#22
 db #22,#09,#09,#09,#09,#09,#09,#09
 db #22,#22,#09,#09,#22,#22,#09,#09
 db #09,#09,#09,#09,#09,#09,#09,#09
 db #09,#09,#16,#16,#16,#16,#16,#16
 db #16,#16,#16,#16,#16,#16,#16,#16
 db #16,#16,#09,#09,#09,#09,#09,#16
 db #09,#09,#09,#09,#09,#16,#09,#09
 db #09,#09,#16,#16,#16,#16,#16,#16
 db #09,#09,#09,#09,#1F,#1F,#1F,#1F	;tady to přestane hrát počínaje paternem #1F!!!
 db #09,#09,#09,#09,#09,#09,#16,#16
 db #09,#09,#09,#09,#1F,#1F,#1F,#1F
 db #16,#16,#16,#16,#1F,#1F,#1F,#1F
 db #1F,#1F,#1F,#1F,#09,#16,#09,#16
 db #09,#09,#09,#09,#09,#09,#09,#09 	;bylo #16
 db #16,#16,#16,#16,#16,#16,#16,#16
 db #16,#16,#16,#16,#16,#16,#16,#16
 db #23,#23,#23,#23,#23,#23,#23,#23
 db #00,#00,#00,#00,#00,#00,#00,#00
 db #FF

;track3
mommaintr3 
; db #14,#1F,#1F,#1F,#1F			;test
 db      #00,#00,#00,#00,#1C,#07,#07	;c611
 db  #07,#07,#04,#04,#07,#07,#04,#04
 db  #07,#07,#04,#04,#07,#07,#08,#08
 db  #08,#08,#07,#07,#04,#04,#0E,#10
 db  #10,#04,#04,#07,#07,#04,#04,#07
 db  #07,#08,#08,#08,#08,#08,#08,#08
 db  #08,#07,#07,#07,#07,#15,#15,#18
 db  #1A,#1C,#07,#07,#07,#07,#07,#07
 db  #04,#04,#07,#07,#08,#08,#0E,#0E
 db  #21,#04,#04,#07,#07,#04,#04,#07
 db  #07,#08,#08,#08,#08,#07,#07,#07
 db  #07,#08,#08,#08,#08,#08,#08,#08
 db  #08,#10,#10,#04,#04,#07,#07,#04
 db  #04,#07,#07,#15,#15,#24,#24,#00
 db  #00,#00,#00,#00,#00,#00,#00,#00
 db  #00,#00,#00,#00,#00,#FF


;track 1 success
momsuc1
	db #26,#25,#00,#00,#FE		;c68e

;track 2 intro
momsuc2
	db #23,#FF			;c693

;track 3 intro
momsuc3
	db #13,#24,#00,#FE		;c695


;track 1 game over
momgameover1
	db     #27,#28,#00,#03,#00,#02,#02	;c699
	db #00,#00,#24,#24,#FE

;track 2 game over
momgameover2
	db #09,#09,#23,#1F,#1F,#23,#09,#09	;c6a5
	db #23,#23,#23,#00,#FE

;track 3 game over
momgameover3
	db #04,#04,#24,#08,#08,#24,#07,#07	;c6b2
	db #24,#24,#24,#24,#FE


;====================================
;patterns
;====================================

ptn00 
 db  #5F,#4F,#FF			;c6bf

ptn01					;c6c6
 db                         #83,#0A 
 db #48,#03,#3C,#03,#46,#03,#45,#03
 db #43,#03,#3C,#03,#46,#03,#3C,#03
 db #45,#03,#3C,#03,#41,#03,#3C,#03
 db #43,#03,#37,#03,#41,#03,#40,#03
 db #3E,#03,#37,#03,#41,#03,#37,#03
 db #40,#03,#37,#03,#3C,#03,#37,#FF

ptn02					;c6f8
 db #03,#4A,#03,#3E,#03,#47,#03,#3E
 db #03,#45,#03,#47,#03,#48,#03,#3E
 db #03,#47,#03,#3E,#03,#43,#03,#3E
 db #FF

ptn03
 db         #03,#4B,#03,#3F,#03,#49	;c72a
 db #03,#48,#03,#46,#03,#3F,#03,#49
 db #03,#3F,#03,#48,#03,#3F,#03,#44
 db #03,#3F,#03,#46,#03,#3A,#03,#44
 db #03,#43,#03,#41,#03,#3A,#03,#44
 db #03,#3A,#03,#43,#03,#3A,#03,#3F
 db #03,#3A,#FF

ptn04
 db         #8F,#03,#18,#87,#04,#2E	;cb5a
 db #87,#03,#24,#07,#1D,#07,#1F,#FF

ptn05
 db                 #87,#05,#3C,#03	;c81c
 db #3A,#03,#39,#07,#37,#07,#3A,#07
 db #39,#07,#35,#07,#37,#07,#33,#03
 db #32,#03,#33,#07,#35,#07,#33,#07
 db #30,#FF

ptn06
 db         #8F,#06,#4F,#0F,#4D,#07  	;c83a
 db #4A,#07,#4B,#0F,#4A,#0F,#48,#0F
 db #47,#FF

ptn07
 db #8F,#03,#13,#87,#04,#2E,#87,#03	;cb68
 db #1F,#07,#18,#07,#1A,#FF

ptn08
 db #8F,#03				;cb76
 db #1B,#87,#04,#2E,#87,#03,#27,#07
 db #20,#07,#22,#FF

ptn09
 db 	#87,#07,#1F,#87,#08,#3C,#07 	;caf9
 db #30,#87,#07,#1F,#87,#08,#3C,#03
 db #30,#83,#07,#1F,#FF

ptn0a
 db         #87,#05,#37,#07,#34,#03	;c84a
 db #32,#03,#34,#07,#35,#07,#34,#07
 db #30,#07,#2F,#87,#01,#3E,#03,#39
 db #03,#3B,#07,#3C,#07,#3B,#07,#3E
 db #07,#3F,#83,#09,#4F,#03,#4B,#07
 db #4A,#07,#4D,#07,#4B,#07,#48,#07
 db #46,#03,#4F,#03,#4B,#07,#4A,#07
 db #4D,#07,#4B,#07,#4A,#07,#3F,#87
 db #0A,#43,#03,#3E,#03,#3F,#07,#41
 db #07,#3F,#07,#3C,#07,#3A,#83,#09
 db #4F,#03,#4B,#07,#4A,#07,#4D,#07
 db #4B,#07,#48,#FF

ptn0b
 db 		    #87,#0A,#41,#03    ;c8a4
 db #41,#03,#3E,#07,#3C,#07,#3F,#07
 db #3E,#07,#3A,#FF

ptn0c
 db 		    #87,#06,#4F,#03	;c8b4
 db #4F,#03,#4B,#07,#4A,#07,#4D,#07
 db #4B,#07,#48,#FF

ptn0d
 db 		    #07,#4A,#83,#01   	;c8c4
 db #32,#03,#33,#07,#32,#07,#30,#07
 db #32,#07,#2E,#FF

ptn0e
 db 		    #8F,#03,#16,#87   	;cb84
 db #04,#2E,#87,#03,#22,#07,#1B,#07
 db #1D,#FF

ptn0f
 db 		    #8F,#06,#33,#07	;c8d4
 db #33,#07,#33,#0F,#32,#3F,#30,#0F
 db #30,#8F,#06,#37,#07,#37,#07,#37 
 db #0F,#35,#3F,#34,#0F,#34,#FF

ptn10
 db         #8F,#03,#1B,#8F,#04,#2E	;cb92
 db #8F,#03,#16,#1F,#18,#8F,#04,#32
 db #FF

ptn11
 db                             #87	;c8ef
 db #05,#48,#03,#46,#03,#45,#07,#43
 db #07,#46,#02,#45,#01,#46,#02,#45
 db #07,#41,#07,#43,#07,#3F,#03,#3E
 db #03,#3F,#07,#41,#02,#3F,#01,#41
 db #02,#3F,#07,#3C,#87,#05,#3E,#83
 db #09,#56,#03,#53,#07,#51,#07,#54
 db #07,#53,#07,#4F,#07,#56,#07,#53
 db #03,#51,#03,#53,#07,#54,#07,#53
 db #07,#4F,#FF

ptn12
 db             #87,#06,#52,#87,#0A	;c933
 db #4B,#07,#4D,#03,#4B,#03,#4A,#07
 db #48,#03,#4A,#03,#4B,#1F,#46,#43
 db #81,#06,#2E,#01,#33,#01,#3A,#01
 db #3F,#01,#46,#01,#4B,#87,#06,#52
 db #87,#0A,#4B,#07,#4D,#03,#4B,#03
 db #4A,#07,#48,#03,#4A,#03,#4B,#1F
 db #4F,#43,#81,#06,#2E,#01,#33,#01
 db #3A,#01,#3F,#01,#46,#01,#4B,#FF

ptn13
 db #87,#06,#4F,#83,#07,#43,#03,#44	;c978
 db #07,#43,#07,#41,#07,#43,#07,#44
 db #07,#3E,#83,#01,#3E,#03,#3F,#07
 db #3E,#07,#3C,#07,#3E,#07,#3F,#07
 db #37,#83,#07,#37,#03,#38,#07,#37
 db #07,#35,#07,#37,#07,#38,#07,#32
 db #83,#01,#32,#03,#33,#07,#32,#07
 db #30,#07,#2F,#07,#2B,#FF

ptn14
 db                         #BF,#0C	;c9b6
 db #4F,#0F,#4F,#17,#50,#07,#4A,#07 
 db #4F,#07,#50,#1F,#50,#0F,#49,#3F
 db #4F,#0F,#4F,#FF

ptn15
 db     #BF,#0D,#18,#0F,#18,#3F,#13	;cba1
 db #0F,#13,#3F,#11,#0F,#11,#3F,#13
 db #0F,#13,#3F,#1B,#0F,#1B,#3F,#1D
 db #0F,#1D,#3F,#19,#0F,#19,#3F,#13
 db #0F,#13,#FF

ptn16
 db                     #87,#07,#1F	;cb0d
 db #87,#0E,#48,#07,#30,#87,#07,#1F
 db #87,#0E,#48,#03,#30,#83,#07,#1F
 db #FF

ptn17
 db                 #87,#08,#48,#03	;c9cc
 db #46,#03,#45,#07,#43,#07,#46,#07
 db #45,#07,#41,#07,#43,#07,#3F,#03
 db #3E,#03,#3F,#07,#41,#07,#3F,#07
 db #3C,#0F,#3E,#0F,#3C,#87,#03,#3C
 db #07,#3E,#0F,#3F,#0F,#41,#0F,#3E
 db #0F,#3C,#0F,#38,#0F,#3A,#3F,#37
 db #0F,#37,#FF

ptn18
 db 		#9F,#08,#24,#07,#3C	;ca03
 db #03,#3A,#03,#39,#07,#37,#07,#3A
 db #07,#39,#07,#35,#07,#37,#07,#33
 db #03,#32,#03,#33,#07,#35,#07,#33
 db #07,#30,#8F,#03,#2B,#0F,#2C,#0F
 db #2E,#0F,#2B,#0F,#35,#0F,#31,#0F
 db #33,#3F,#30,#0F,#30,#FF

ptn19
 db 			    #9F,#03	;ca36
 db #1F,#87,#0F,#4F,#03,#4D,#03,#4C
 db #07,#4A,#07,#4D,#07,#4C,#07,#48
 db #07,#4A,#07,#47,#03,#45,#03,#47
 db #07,#48,#07,#47,#07,#43,#87,#03
 db #37,#07,#39,#0F,#3A,#0F,#3C,#0F
 db #39,#0F,#37,#0F,#33,#0F,#35,#3F
 db #32,#0F,#32,#FF

ptn1a
 db 		    #87,#0F,#43,#03	;ca6c
 db #41,#03,#40,#07,#3E,#07,#41,#07
 db #40,#07,#3C,#07,#3E,#07,#3B,#03
 db #39,#03,#3B,#07,#3C,#07,#3B,#07
 db #37,#8F,#03,#2D,#0F,#2F,#07,#30
 db #07,#32,#0F,#33,#0F,#35,#0F,#32
 db #0F,#30,#0F,#2C,#0F,#2E,#3F,#2B
 db #0F,#2B,#FF

ptn1b
 db 		#8F,#03,#30,#07,#2E	;caa3
 db #07,#2D,#0F,#2B,#0F,#2E,#07,#2D
 db #03,#2E,#03,#2D,#0F,#29,#0F,#2B
 db #0F,#27,#07,#26,#07,#27,#0F,#29
 db #07,#27,#03,#29,#03,#27,#0F,#24
 db #FF

ptn1c
 db     #8F,#03,#29,#07,#27,#07,#26	;cac9
 db #0F,#24,#0F,#27,#07,#26,#03,#27
 db #03,#26,#0F,#22,#0F,#24,#0F,#20
 db #07,#1F,#07,#20,#0F,#22,#07,#20
 db #03,#22,#03,#20,#0F,#1D,#FF

ptn1d
 db 				#BF	;caef
 db #00,#2B,#2F,#2B,#3F,#2B,#2F,#2B
 db #FF

ptn1e
 db 	#03,#46,#03,#3A,#03,#44,#03	;c711
 db #43,#03,#41,#03,#3A,#03,#44,#03
 db #3A,#03,#43,#03,#3A,#03,#3F,#03
 db #3A,#FF

ptn1f
 db     #87,#07,#1F,#87,#08,#46,#07	;cb21
 db #3A,#87,#07,#1F,#87,#08,#46,#03
 db #3A,#83,#07,#1F,#FF

ptn20
 db 	    #87,#04,#28,#83,#09,#5B	;c762
 db #03,#5C,#03,#5B,#03,#37,#03,#59
 db #03,#37,#03,#5B,#03,#37,#03,#5D
 db #03,#37,#03,#56,#03,#37,#03,#56
 db #03,#57,#03,#56,#03,#37,#03,#54
 db #03,#37,#03,#56,#03,#37,#03,#57
 db #03,#37,#03,#4F,#03,#37,#03,#4F
 db #03,#50,#03,#4F,#03,#37,#03,#4D
 db #03,#37,#03,#4F,#03,#37,#03,#50
 db #03,#37,#03,#4A,#03,#37,#03,#4A
 db #03,#4B,#03,#4A,#03,#37,#03,#48
 db #03,#37,#03,#47,#03,#37,#03,#43
 db #03,#37,#FF

ptn21
 db 		#97,#03,#13,#83,#09	;c7c3
 db #4F,#03,#50,#03,#4F,#03,#37,#03
 db #4D,#03,#37,#03,#4F,#03,#37,#03
 db #50,#03,#37,#03,#4A,#03,#37,#03
 db #4A,#03,#4B,#03,#4A,#03,#37,#03
 db #48,#03,#37,#03,#4A,#03,#37,#03
 db #4B,#03,#37,#03,#43,#03,#37,#03 
 db #43,#03,#44,#03,#43,#03,#37,#03
 db #41,#03,#37,#03,#43,#03,#37,#03 
 db #44,#03,#37,#03,#3E,#03,#37,#03 
 db #3E,#03,#3F,#03,#3B,#03,#37,#03
 db #37,#03,#37,#FF

ptn22
 db 			#87,#07,#1F	;cb35
 db #87,#10,#5B,#07,#5B,#87,#07,#1F
 db #87,#10,#5B,#03,#5B,#83,#07,#1F
 db #FF

ptn23
 db 	#47,#87,#0E,#48,#07,#30,#47	;cb49
 db #07,#48,#07,#30,#FF

ptn24
 db 		#3F,#18,#0F,#18,#FF	;cb55

ptn25
 db #03,#5C,#03,#5B,#03,#37,#03,#59	;c768
 db #03,#37,#03,#5B,#03,#37,#03,#5D
 db #03,#37,#03,#56,#03,#37,#03,#56
 db #03,#57,#03,#56,#03,#37,#03,#54
 db #03,#37,#03,#56,#03,#37,#03,#57
 db #03,#37,#03,#4F,#03,#37,#03,#4F
 db #03,#50,#03,#4F,#03,#37,#03,#4D
 db #03,#37,#03,#4F,#03,#37,#03,#50
 db #03,#37,#03,#4A,#03,#37,#03,#4A
 db #03,#4B,#03,#4A,#03,#37,#03,#48
 db #03,#37,#03,#47,#03,#37,#03,#43
 db #03,#37,#FF

ptn26
 db #87,#04,#28,#83,#0B,#5B,#FF		;c75b

ptn27
 db #83,#07,#48,#FF			;c6c2

ptn28
 db 	#03,#3C,#03,#46,#03,#45,#03	;c6c9
 db #43,#03,#3C,#03,#46,#03,#3C,#03
 db #45,#03,#3C,#03,#41,#03,#3C,#03
 db #43,#03,#37,#03,#41,#03,#40,#03
 db #3E,#03,#37,#03,#41,#03,#37,#03
 db #40,#03,#37,#03,#3C,#03,#37,#FF









;====================================
;instruments
;====================================

instr
 db #00,#02,#41,#49,#6C,#02,#00,#00	;C427
 db #A0,#07,#41,#59,#6C,#02,#00,#00
 db #00,#01,#41,#78,#8C,#03,#00,#00
 db #10,#01,#41,#0B,#00,#00,#10,#08
 db #00,#01,#81,#0A,#09,#00,#00,#05
 db #00,#01,#41,#79,#C0,#02,#00,#00
 db #00,#08,#41,#09,#30,#02,#00,#04
 db #00,#08,#11,#0F,#0F,#00,#00,#05
 db #00,#08,#11,#0B,#00,#00,#00,#04
 db #00,#08,#11,#0A,#A0,#02,#00,#00
 db #80,#09,#41,#78,#50,#02,#41,#00
 db #00,#02,#41,#08,#06,#00,#00,#01
 db #70,#04,#41,#0C,#20,#01,#79,#0A
 db #80,#09,#41,#0F,#F0,#00,#41,#00
 db #00,#08,#15,#0A,#09,#00,#00,#05
 db #00,#08,#41,#03,#50,#00,#00,#04
 db #00,#08,#15,#05,#0A,#00,#00,#05

/*instruments from Monty On The Run
instr 
 db #80,#09,#41,#48,#60,#03,#81,#00
 db #00,#08,#81,#02,#08,#00,#00,#01
 db #a0,#02,#41,#09,#80,#00,#00,#00
 db #00,#02,#81,#09,#09,#00,#00,#05
 db #00,#08,#41,#08,#50,#02,#00,#04
 db #00,#01,#41,#3f,#c0,#02,#00,#00
 db #00,#08,#41,#04,#40,#02,#00,#00
 db #00,#08,#41,#09,#00,#02,#00,#00
 db #00,#09,#41,#09,#70,#02,#5f,#04
 db #00,#09,#41,#4a,#69,#02,#81,#00		
 db #00,#09,#41,#40,#6f,#00,#81,#02
 db #80,#07,#81,#0a,#0a,#00,#00,#01
 db #00,#09,#41,#3f,#ff,#01,#e7,#02	;#C
 db #00,#08,#41,#90,#f0,#01,#e8,#02
 db #00,#08,#41,#06,#0a,#00,#00,#01
 db #00,#09,#41,#19,#70,#02,#a8,#00
 db #00,#02,#41,#09,#90,#02,#00,#00
 db #00,#00,#11,#0a,#fa,#00,#00,#05
 db #00,#08,#41,#37,#40,#02,#00,#00
 db #00,#08,#11,#07,#70,#02,#00,#00
*/

end